Index: uspace/lib/pcut/src/report/xml.c
===================================================================
--- uspace/lib/pcut/src/report/xml.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/report/xml.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -135,20 +135,17 @@
 	const char *status_str = NULL;
 
-	if (outcome != TEST_OUTCOME_PASS) {
+	if (outcome != PCUT_OUTCOME_PASS) {
 		failed_tests_in_suite++;
 	}
 
 	switch (outcome) {
-	case TEST_OUTCOME_PASS:
+	case PCUT_OUTCOME_PASS:
 		status_str = "pass";
 		break;
-	case TEST_OUTCOME_FAIL:
+	case PCUT_OUTCOME_FAIL:
 		status_str = "fail";
 		break;
-	case TEST_OUTCOME_ERROR:
+	default:
 		status_str = "error";
-		break;
-	default:
-		/* Shall not get here. */
 		break;
 	}
Index: uspace/lib/pcut/src/run.c
===================================================================
--- uspace/lib/pcut/src/run.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/src/run.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -73,9 +73,8 @@
 static int default_suite_initialized = 0;
 
-static void init_default_suite_when_needed(void)
-{
-	if (default_suite_initialized)
+static void init_default_suite_when_needed() {
+	if (default_suite_initialized) {
 		return;
-	
+	}
 	default_suite.id = -1;
 	default_suite.kind = PCUT_KIND_TESTSUITE;
@@ -92,13 +91,11 @@
  * @return Always a valid test suite item.
  */
-static pcut_item_t *pcut_find_parent_suite(pcut_item_t *it)
-{
+static pcut_item_t *pcut_find_parent_suite(pcut_item_t *it) {
 	while (it != NULL) {
-		if (it->kind == PCUT_KIND_TESTSUITE)
+		if (it->kind == PCUT_KIND_TESTSUITE) {
 			return it;
-		
+		}
 		it = it->previous;
 	}
-	
 	init_default_suite_when_needed();
 	return &default_suite;
@@ -109,8 +106,8 @@
  * @param func Function to run (can be NULL).
  */
-static void run_setup_teardown(pcut_setup_func_t func)
-{
-	if (func != NULL)
+static void run_setup_teardown(pcut_setup_func_t func) {
+	if (func != NULL) {
 		func();
+	}
 }
 
@@ -122,11 +119,11 @@
  * @param outcome Outcome of the current test.
  */
-static void leave_test(int outcome)
-{
+static void leave_test(int outcome) {
 	PCUT_DEBUG("leave_test(outcome=%d), will_exit=%s", outcome,
-	    leave_means_exit ? "yes" : "no");
-	if (leave_means_exit)
+		leave_means_exit ? "yes" : "no");
+	if (leave_means_exit) {
 		exit(outcome);
-	
+	}
+
 #ifndef PCUT_NO_LONG_JUMP
 	longjmp(start_test_jump, 1);
@@ -141,8 +138,6 @@
  * @param message Message describing the failure.
  */
-void pcut_failed_assertion(const char *message)
-{
+void pcut_failed_assertion(const char *message) {
 	static const char *prev_message = NULL;
-	
 	/*
 	 * The assertion failed. We need to abort the current test,
@@ -150,27 +145,28 @@
 	 * include running the tear-down routine.
 	 */
-	if (print_test_error)
+	if (print_test_error) {
 		pcut_print_fail_message(message);
-	
+	}
+
 	if (execute_teardown_on_failure) {
 		execute_teardown_on_failure = 0;
 		prev_message = message;
 		run_setup_teardown(current_suite->teardown_func);
-		
+
 		/* Tear-down was okay. */
 		if (report_test_result) {
-			pcut_report_test_done(current_test, TEST_OUTCOME_FAIL,
+			pcut_report_test_done(current_test, PCUT_OUTCOME_FAIL,
 				message, NULL, NULL);
 		}
 	} else {
 		if (report_test_result) {
-			pcut_report_test_done(current_test, TEST_OUTCOME_FAIL,
+			pcut_report_test_done(current_test, PCUT_OUTCOME_FAIL,
 				prev_message, message, NULL);
 		}
 	}
-	
+
 	prev_message = NULL;
-	
-	leave_test(TEST_OUTCOME_FAIL); /* No return. */
+
+	leave_test(PCUT_OUTCOME_FAIL); /* No return. */
 }
 
@@ -180,6 +176,5 @@
  * @return Error status (zero means success).
  */
-static int run_test(pcut_item_t *test)
-{
+static int run_test(pcut_item_t *test) {
 	/*
 	 * Set here as the returning point in case of test failure.
@@ -187,19 +182,20 @@
 	 * test execution.
 	 */
-	
 #ifndef PCUT_NO_LONG_JUMP
 	int test_finished = setjmp(start_test_jump);
-	if (test_finished)
-		return 1;
+	if (test_finished) {
+		return PCUT_OUTCOME_FAIL;
+	}
 #endif
-	
-	if (report_test_result)
+
+	if (report_test_result) {
 		pcut_report_test_start(test);
-	
+	}
+
 	current_suite = pcut_find_parent_suite(test);
 	current_test = test;
-	
+
 	pcut_hook_before_test(test);
-	
+
 	/*
 	 * If anything goes wrong, execute the tear-down function
@@ -207,10 +203,10 @@
 	 */
 	execute_teardown_on_failure = 1;
-	
+
 	/*
 	 * Run the set-up function.
 	 */
 	run_setup_teardown(current_suite->setup_func);
-	
+
 	/*
 	 * The setup function was performed, it is time to run
@@ -218,5 +214,5 @@
 	 */
 	test->test_func();
-	
+
 	/*
 	 * Finally, run the tear-down function. We need to clear
@@ -225,14 +221,15 @@
 	execute_teardown_on_failure = 0;
 	run_setup_teardown(current_suite->teardown_func);
-	
+
 	/*
 	 * If we got here, it means everything went well with
 	 * this test.
 	 */
-	if (report_test_result)
-		pcut_report_test_done(current_test, TEST_OUTCOME_PASS,
-		    NULL, NULL, NULL);
-	
-	return 0;
+	if (report_test_result) {
+		pcut_report_test_done(current_test, PCUT_OUTCOME_PASS,
+			NULL, NULL, NULL);
+	}
+
+	return PCUT_OUTCOME_PASS;
 }
 
@@ -245,15 +242,16 @@
  * @return Error status (zero means success).
  */
-int pcut_run_test_forked(pcut_item_t *test)
-{
+int pcut_run_test_forked(pcut_item_t *test) {
+	int rc;
+
 	report_test_result = 0;
 	print_test_error = 1;
 	leave_means_exit = 1;
-	
-	int rc = run_test(test);
-	
+
+	rc = run_test(test);
+
 	current_test = NULL;
 	current_suite = NULL;
-	
+
 	return rc;
 }
@@ -267,15 +265,16 @@
  * @return Error status (zero means success).
  */
-int pcut_run_test_single(pcut_item_t *test)
-{
+int pcut_run_test_single(pcut_item_t *test) {
+	int rc;
+
 	report_test_result = 1;
 	print_test_error = 0;
 	leave_means_exit = 0;
-	
-	int rc = run_test(test);
-	
+
+	rc = run_test(test);
+
 	current_test = NULL;
 	current_suite = NULL;
-	
+
 	return rc;
 }
@@ -286,16 +285,16 @@
  * @return Timeout in seconds.
  */
-int pcut_get_test_timeout(pcut_item_t *test)
-{
+int pcut_get_test_timeout(pcut_item_t *test) {
 	int timeout = PCUT_DEFAULT_TEST_TIMEOUT;
 	pcut_extra_t *extras = test->extras;
-	
+
+
 	while (extras->type != PCUT_EXTRA_LAST) {
-		if (extras->type == PCUT_EXTRA_TIMEOUT)
+		if (extras->type == PCUT_EXTRA_TIMEOUT) {
 			timeout = extras->timeout;
-		
+		}
 		extras++;
 	}
-	
+
 	return timeout;
 }
Index: uspace/lib/pcut/tests/beforeafter.c
===================================================================
--- uspace/lib/pcut/tests/beforeafter.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/tests/beforeafter.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -28,4 +28,5 @@
 
 #define _BSD_SOURCE
+#define _DEFAULT_SOURCE
 
 #include <pcut/pcut.h>
Index: uspace/lib/pcut/tests/timeout.c
===================================================================
--- uspace/lib/pcut/tests/timeout.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/tests/timeout.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -29,10 +29,13 @@
 #include <pcut/pcut.h>
 
+#ifdef __helenos__
+#include <thread.h>
+#else
 #ifdef __unix
-// FIXME
-#include <thread.h>
+#include <unistd.h>
 #endif
 #if defined(__WIN64) || defined(__WIN32) || defined(_WIN32)
 #include <windows.h>
+#endif
 #endif
 
@@ -41,10 +44,13 @@
 
 static void my_sleep(int sec) {
+#ifdef __helenos__
+	thread_sleep(sec);
+#else
 #ifdef __unix
-// FIXME
-	thread_sleep(sec);
+	sleep(sec);
 #endif
 #if defined(__WIN64) || defined(__WIN32) || defined(_WIN32)
 	Sleep(1000 * sec);
+#endif
 #endif
 }
Index: uspace/lib/pcut/tests/xmlreport.c
===================================================================
--- uspace/lib/pcut/tests/xmlreport.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/pcut/tests/xmlreport.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -30,4 +30,6 @@
 #include "tested.h"
 
+#include <pcut/pcut.h>
+#include "tested.h"
 
 PCUT_INIT
Index: uspace/lib/posix/source/fcntl.c
===================================================================
--- uspace/lib/posix/source/fcntl.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/posix/source/fcntl.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -135,6 +135,7 @@
 	    ((posix_flags & O_APPEND) ? MODE_APPEND : 0);
 
-	int file = rcerrno(vfs_lookup, pathname, flags);
-	if (file < 0)
+	int file;
+	rc = rcerrno(vfs_lookup, pathname, flags, &file);
+	if (rc != EOK)
 		return -1;
 
Index: uspace/lib/posix/source/stdio.c
===================================================================
--- uspace/lib/posix/source/stdio.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/posix/source/stdio.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -343,7 +343,8 @@
 {
 	const int fildes = *(int *) fd;
-	ssize_t wr = vfs_write(fildes, &posix_pos[fildes], str, size);
-	if (wr < 0)
-		return wr;
+	size_t wr;
+	int rc = vfs_write(fildes, &posix_pos[fildes], str, size, &wr);
+	if (rc != EOK)
+		return rc;
 	return str_nlength(str, wr);
 }
@@ -371,5 +372,6 @@
 		
 		const int fildes = *(int *) fd;
-		if (vfs_write(fildes, &posix_pos[fildes], buf, sz) < 0)
+		size_t nwr;
+		if (vfs_write(fildes, &posix_pos[fildes], buf, sz, &nwr) != EOK)
 			break;
 		
Index: uspace/lib/posix/source/time.c
===================================================================
--- uspace/lib/posix/source/time.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/posix/source/time.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -45,5 +45,5 @@
 #include "posix/assert.h"
 
-#include "libc/fibril_synch.h"
+#include "libc/async.h"
 #include "libc/malloc.h"
 #include "libc/task.h"
@@ -314,8 +314,8 @@
 			// TODO: interruptible sleep
 			if (rqtp->tv_sec != 0) {
-				fibril_sleep(rqtp->tv_sec);
+				async_sleep(rqtp->tv_sec);
 			}
 			if (rqtp->tv_nsec != 0) {
-				fibril_usleep(rqtp->tv_nsec / 1000);
+				async_usleep(rqtp->tv_nsec / 1000);
 			}
 			return 0;
Index: uspace/lib/posix/source/unistd.c
===================================================================
--- uspace/lib/posix/source/unistd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/posix/source/unistd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -213,8 +213,11 @@
 ssize_t posix_read(int fildes, void *buf, size_t nbyte)
 {
-	ssize_t size = rcerrno(vfs_read, fildes, &posix_pos[fildes], buf, nbyte);
-	if (size < 0)
-		return -1;
-	return size;
+	size_t nread;
+	int rc;
+
+	rc = rcerrno(vfs_read, fildes, &posix_pos[fildes], buf, nbyte, &nread);
+	if (rc != EOK)
+		return -1;
+	return (ssize_t) nread;
 }
 
@@ -229,8 +232,11 @@
 ssize_t posix_write(int fildes, const void *buf, size_t nbyte)
 {
-	ssize_t size = rcerrno(vfs_write, fildes, &posix_pos[fildes], buf, nbyte);
-	if (size < 0)
-		return -1;
-	return size;
+	size_t nwr;
+	int rc;
+
+	rc = rcerrno(vfs_write, fildes, &posix_pos[fildes], buf, nbyte, &nwr);
+	if (rc != EOK)
+		return -1;
+	return nwr;
 }
 
@@ -349,5 +355,11 @@
 int posix_dup2(int fildes, int fildes2)
 {
-	return negerrno(vfs_clone, fildes, fildes2, false);
+	int file;
+	int rc = vfs_clone(fildes, fildes2, false, &file);
+	if (rc != EOK) {
+		errno = rc < 0 ? -rc : rc;
+		return -1;
+	}
+	return file;
 }
 
Index: uspace/lib/usbhid/src/hiddescriptor.c
===================================================================
--- uspace/lib/usbhid/src/hiddescriptor.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhid/src/hiddescriptor.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,8 +36,8 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
 #include <mem.h>
 #include <usb/debug.h>
 #include <assert.h>
+#include <stdlib.h>
 
 
Index: uspace/lib/usbhid/src/hidparser.c
===================================================================
--- uspace/lib/usbhid/src/hidparser.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhid/src/hidparser.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,5 +36,5 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
+#include <stdlib.h>
 #include <mem.h>
 #include <usb/debug.h>
Index: uspace/lib/usbhid/src/hidpath.c
===================================================================
--- uspace/lib/usbhid/src/hidpath.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhid/src/hidpath.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,6 +36,6 @@
 #include <errno.h>
 #include <stdio.h>
-#include <malloc.h>
 #include <mem.h>
+#include <stdlib.h>
 #include <usb/debug.h>
 #include <assert.h>
Index: uspace/lib/usbhost/include/usb/host/ddf_helpers.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/ddf_helpers.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhost/include/usb/host/ddf_helpers.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -48,5 +48,5 @@
 typedef void (*driver_fini_t)(hcd_t *);
 typedef int (*claim_t)(ddf_dev_t *);
-typedef int (*irq_code_gen_t)(irq_code_t *, const hw_res_list_parsed_t *);
+typedef int (*irq_code_gen_t)(irq_code_t *, const hw_res_list_parsed_t *, int *);
 
 typedef struct {
@@ -75,6 +75,7 @@
     const hw_res_list_parsed_t *hw_res,
     interrupt_handler_t handler,
-    int (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *));
-void ddf_hcd_gen_irq_handler(ipc_callid_t iid, ipc_call_t *call, ddf_dev_t *dev);
+    int (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *, int *),
+    cap_handle_t *handle);
+void ddf_hcd_gen_irq_handler(ipc_call_t *call, ddf_dev_t *dev);
 
 #endif
Index: uspace/lib/usbhost/include/usb/host/hcd.h
===================================================================
--- uspace/lib/usbhost/include/usb/host/hcd.h	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhost/include/usb/host/hcd.h	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -102,5 +102,5 @@
 }
 
-extern usb_address_t hcd_request_address(hcd_t *, usb_speed_t);
+extern int hcd_request_address(hcd_t *, usb_speed_t, usb_address_t *);
 
 extern int hcd_release_address(hcd_t *, usb_address_t);
@@ -123,6 +123,6 @@
     usbhc_iface_transfer_out_callback_t, void *, const char *);
 
-extern ssize_t hcd_send_batch_sync(hcd_t *, usb_target_t, usb_direction_t,
-    void *, size_t, uint64_t, const char *);
+extern int hcd_send_batch_sync(hcd_t *, usb_target_t, usb_direction_t,
+    void *, size_t, uint64_t, const char *, size_t *);
 
 #endif
Index: uspace/lib/usbhost/src/ddf_helpers.c
===================================================================
--- uspace/lib/usbhost/src/ddf_helpers.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhost/src/ddf_helpers.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -481,9 +481,10 @@
 	}};
 
-	const usb_address_t address = hcd_request_address(hcd, speed);
-	if (address < 0) {
+	usb_address_t address;
+	ret = hcd_request_address(hcd, speed, &address);
+	if (ret != EOK) {
 		usb_log_error("Failed to reserve new address: %s.",
-		    str_error(address));
-		return address;
+		    str_error(ret));
+		return ret;
 	}
 
@@ -518,10 +519,14 @@
 	usb_log_debug("Device(%d): Requesting first 8B of device descriptor.",
 	    address);
-	ssize_t got = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_IN,
+	size_t got;
+	ret = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_IN,
 	    &desc, CTRL_PIPE_MIN_PACKET_SIZE, *(uint64_t *)&get_device_desc_8,
-	    "read first 8 bytes of dev descriptor");
-
-	if (got != CTRL_PIPE_MIN_PACKET_SIZE) {
-		ret = got < 0 ? got : EOVERFLOW;
+	    "read first 8 bytes of dev descriptor", &got);
+
+	if (ret == EOK && got != CTRL_PIPE_MIN_PACKET_SIZE) {
+		ret = EOVERFLOW;
+	}
+
+	if (ret != EOK) {
 		usb_log_error("Device(%d): Failed to get 8B of dev descr: %s.",
 		    address, str_error(ret));
@@ -552,16 +557,16 @@
 
 	usb_log_debug("Device(%d): Setting USB address.", address);
-	got = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_OUT,
-	    NULL, 0, *(uint64_t *)&set_address, "set address");
+	ret = hcd_send_batch_sync(hcd, default_target, USB_DIRECTION_OUT,
+	    NULL, 0, *(uint64_t *)&set_address, "set address", &got);
 
 	usb_log_debug("Device(%d): Removing default (0:0) EP.", address);
 	hcd_remove_ep(hcd, default_target, USB_DIRECTION_BOTH);
 
-	if (got != 0) {
+	if (ret != EOK) {
 		usb_log_error("Device(%d): Failed to set new address: %s.",
-		    address, str_error(got));
+		    address, str_error(ret));
 		hcd_remove_ep(hcd, target, USB_DIRECTION_BOTH);
 		hcd_release_address(hcd, address);
-		return got;
+		return ret;
 	}
 
@@ -572,7 +577,7 @@
 	usb_log_debug("Device(%d): Requesting full device descriptor.",
 	    address);
-	got = hcd_send_batch_sync(hcd, target, USB_DIRECTION_IN,
+	ret = hcd_send_batch_sync(hcd, target, USB_DIRECTION_IN,
 	    &desc, sizeof(desc), *(uint64_t *)&get_device_desc,
-	    "read device descriptor");
+	    "read device descriptor", &got);
 	if (ret != EOK) {
 		usb_log_error("Device(%d): Failed to set get dev descriptor: %s",
@@ -742,11 +747,13 @@
  * @param[in] gen_irq_code IRQ code generator.
  *
- * @return IRQ capability handle on success.
- * @return Negative error code.
+ * @param[out] handle  IRQ capability handle on success.
+ *
+ * @return Error code.
  */
 int hcd_ddf_setup_interrupts(ddf_dev_t *device,
     const hw_res_list_parsed_t *hw_res,
     interrupt_handler_t handler,
-    int (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *hw_res))
+    int (*gen_irq_code)(irq_code_t *, const hw_res_list_parsed_t *, int *),
+    cap_handle_t *handle)
 {
 
@@ -757,30 +764,30 @@
 	irq_code_t irq_code = {0};
 
-	const int irq = gen_irq_code(&irq_code, hw_res);
-	if (irq < 0) {
+	int irq;
+	int ret = gen_irq_code(&irq_code, hw_res, &irq);
+	if (ret != EOK) {
 		usb_log_error("Failed to generate IRQ code: %s.\n",
-		    str_error(irq));
-		return irq;
+		    str_error(ret));
+		return ret;
 	}
 
 	/* Register handler to avoid interrupt lockup */
-	const int irq_cap = register_interrupt_handler(device, irq, handler,
-	    &irq_code);
+	ret = register_interrupt_handler(device, irq, handler,
+	    &irq_code, handle);
 	irq_code_clean(&irq_code);
-	if (irq_cap < 0) {
-		usb_log_error("Failed to register interrupt handler: %s.\n",
-		    str_error(irq_cap));
-		return irq_cap;
-	}
-
-	/* Enable interrupts */
-	int ret = hcd_ddf_enable_interrupt(device, irq);
 	if (ret != EOK) {
 		usb_log_error("Failed to register interrupt handler: %s.\n",
 		    str_error(ret));
-		unregister_interrupt_handler(device, irq_cap);
-		return ret;
-	}
-	return irq_cap;
+		return ret;
+	}
+
+	/* Enable interrupts */
+	ret = hcd_ddf_enable_interrupt(device, irq);
+	if (ret != EOK) {
+		usb_log_error("Failed to register interrupt handler: %s.\n",
+		    str_error(ret));
+		unregister_interrupt_handler(device, *handle);
+	}
+	return ret;
 }
 
@@ -788,8 +795,7 @@
  *
  * @param[in] dev DDF instance of the device to use.
- * @param[in] iid (Unused).
  * @param[in] call Pointer to the call from kernel.
  */
-void ddf_hcd_gen_irq_handler(ipc_callid_t iid, ipc_call_t *call, ddf_dev_t *dev)
+void ddf_hcd_gen_irq_handler(ipc_call_t *call, ddf_dev_t *dev)
 {
 	assert(dev);
@@ -877,17 +883,19 @@
 	interrupt_handler_t *irq_handler =
 	    driver->irq_handler ? driver->irq_handler : ddf_hcd_gen_irq_handler;
-	const int irq_cap = hcd_ddf_setup_interrupts(device, &hw_res,
-	    irq_handler, driver->irq_code_gen);
-	bool irqs_enabled = !(irq_cap < 0);
+	int irq_cap;
+	ret = hcd_ddf_setup_interrupts(device, &hw_res,
+	    irq_handler, driver->irq_code_gen, &irq_cap);
+	bool irqs_enabled = (ret == EOK);
 	if (irqs_enabled) {
 		usb_log_debug("Hw interrupts enabled.\n");
 	}
 
-	if (driver->claim)
+	if (driver->claim) {
 		ret = driver->claim(device);
-	if (ret != EOK) {
-		usb_log_error("Failed to claim `%s' for driver `%s'",
-		    ddf_dev_get_name(device), driver->name);
-		return ret;
+		if (ret != EOK) {
+			usb_log_error("Failed to claim `%s' for driver `%s'",
+			    ddf_dev_get_name(device), driver->name);
+			return ret;
+		}
 	}
 
Index: uspace/lib/usbhost/src/hcd.c
===================================================================
--- uspace/lib/usbhost/src/hcd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/lib/usbhost/src/hcd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -102,13 +102,8 @@
 }
 
-usb_address_t hcd_request_address(hcd_t *hcd, usb_speed_t speed)
-{
-	assert(hcd);
-	usb_address_t address = 0;
-	const int ret = usb_bus_request_address(
-	    &hcd->bus, &address, false, speed);
-	if (ret != EOK)
-		return ret;
-	return address;
+int hcd_request_address(hcd_t *hcd, usb_speed_t speed, usb_address_t *address)
+{
+	assert(hcd);
+	return usb_bus_request_address(&hcd->bus, address, false, speed);
 }
 
@@ -271,7 +266,7 @@
 
 /** this is really ugly version of sync usb communication */
-ssize_t hcd_send_batch_sync(
+int hcd_send_batch_sync(
     hcd_t *hcd, usb_target_t target, usb_direction_t dir,
-    void *data, size_t size, uint64_t setup_data, const char* name)
+    void *data, size_t size, uint64_t setup_data, const char* name, size_t *out_size)
 {
 	assert(hcd);
@@ -289,5 +284,5 @@
 
 	if (sd.ret == EOK)
-		return sd.size;
+		*out_size = sd.size;
 	return sd.ret;
 }
Index: uspace/srv/audio/hound/audio_data.c
===================================================================
--- uspace/srv/audio/hound/audio_data.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/audio/hound/audio_data.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,5 +35,5 @@
 
 #include <macros.h>
-#include <malloc.h>
+#include <stdlib.h>
 
 #include "audio_data.h"
Index: uspace/srv/audio/hound/audio_device.c
===================================================================
--- uspace/srv/audio/hound/audio_device.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/audio/hound/audio_device.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -62,5 +62,5 @@
 	assert(dev);
 	/* we release buffer on stop so this should be enough */
-	return (bool)dev->buffer.base;
+	return dev->buffer.base != NULL;
 }
 
@@ -121,5 +121,7 @@
 {
 	assert(dev);
-	if (audio_pcm_query_cap(dev->sess, AUDIO_CAP_CAPTURE))
+	sysarg_t val;
+	int rc = audio_pcm_query_cap(dev->sess, AUDIO_CAP_CAPTURE, &val);
+	if (rc == EOK && val)
 		return &dev->source;
 	return NULL;
@@ -135,5 +137,7 @@
 {
 	assert(dev);
-	if (audio_pcm_query_cap(dev->sess, AUDIO_CAP_PLAYBACK))
+	sysarg_t val;
+	int rc = audio_pcm_query_cap(dev->sess, AUDIO_CAP_PLAYBACK, &val);
+	if (rc == EOK && val)
 		return &dev->sink;
 	return NULL;
Index: uspace/srv/audio/hound/connection.c
===================================================================
--- uspace/srv/audio/hound/connection.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/audio/hound/connection.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -34,6 +34,6 @@
  */
 
-#include <malloc.h>
 #include <errno.h>
+#include <stdlib.h>
 
 #include "log.h"
Index: uspace/srv/audio/hound/hound_ctx.c
===================================================================
--- uspace/srv/audio/hound/hound_ctx.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/audio/hound/hound_ctx.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -35,7 +35,7 @@
  */
 
-#include <malloc.h>
 #include <macros.h>
 #include <errno.h>
+#include <stdlib.h>
 #include <str_error.h>
 
Index: uspace/srv/bd/file_bd/file_bd.c
===================================================================
--- uspace/srv/bd/file_bd/file_bd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/bd/file_bd/file_bd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -48,4 +48,5 @@
 #include <stdint.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdbool.h>
 #include <task.h>
@@ -134,6 +135,6 @@
 	rc = loc_service_register(device_name, &service_id);
 	if (rc != EOK) {
-		printf("%s: Unable to register device '%s'.\n",
-		    NAME, device_name);
+		printf("%s: Unable to register device '%s': %s.\n",
+		    NAME, device_name, str_error(rc));
 		return rc;
 	}
@@ -141,5 +142,5 @@
 	rc = loc_category_get_id("disk", &disk_cat, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
-		printf("%s: Failed resolving category 'disk'.\n", NAME);
+		printf("%s: Failed resolving category 'disk': %s\n", NAME, str_error(rc));
 		return rc;
 	}
@@ -147,6 +148,6 @@
 	rc = loc_service_add_to_cat(service_id, disk_cat);
 	if (rc != EOK) {
-		printf("%s: Failed adding %s to category.",
-		    NAME, device_name);
+		printf("%s: Failed adding %s to category: %s",
+		    NAME, device_name, str_error(rc));
 		return rc;
 	}
Index: uspace/srv/bd/rd/rd.c
===================================================================
--- uspace/srv/bd/rd/rd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/bd/rd/rd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -48,4 +48,5 @@
 #include <stdbool.h>
 #include <errno.h>
+#include <str_error.h>
 #include <async.h>
 #include <fibril_synch.h>
@@ -179,5 +180,5 @@
 	ret = loc_server_register(NAME);
 	if (ret != EOK) {
-		printf("%s: Unable to register driver (%d)\n", NAME, ret);
+		printf("%s: Unable to register driver: %s\n", NAME, str_error(ret));
 		return false;
 	}
Index: uspace/srv/bd/sata_bd/sata_bd.c
===================================================================
--- uspace/srv/bd/sata_bd/sata_bd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/bd/sata_bd/sata_bd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -41,4 +41,5 @@
 #include <devman.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdio.h>
 #include <str.h>
@@ -251,5 +252,5 @@
 	rc = loc_server_register(NAME);
 	if (rc < 0) {
-		printf(NAME ": Unable to register driver.\n");
+		printf(NAME ": Unable to register driver: %s.\n", str_error(rc));
 		return rc;
 	}
@@ -257,4 +258,5 @@
 	rc = get_sata_disks();
 	if (rc != EOK) {
+		// TODO: log the error
 		return rc;
 	}
@@ -262,5 +264,5 @@
 	rc = loc_category_get_id("disk", &disk_cat, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
-		printf("%s: Failed resolving category 'disk'.\n", NAME);
+		printf("%s: Failed resolving category 'disk': %s.\n", NAME, str_error(rc));
 		return rc;
 	}
@@ -271,5 +273,5 @@
 		rc = loc_service_register(name, &disk[i].service_id);
 		if (rc != EOK) {
-			printf(NAME ": Unable to register device %s.\n", name);
+			printf(NAME ": Unable to register device %s: %s\n", name, str_error(rc));
 			return rc;
 		}
@@ -277,6 +279,6 @@
 		rc = loc_service_add_to_cat(disk[i].service_id, disk_cat);
 		if (rc != EOK) {
-			printf("%s: Failed adding %s to category.",
-			    NAME, disk[i].dev_name);
+			printf("%s: Failed adding %s to category: %s.",
+			    NAME, disk[i].dev_name, str_error(rc));
 			return rc;
 		}
Index: uspace/srv/bd/vbd/disk.c
===================================================================
--- uspace/srv/bd/vbd/disk.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/bd/vbd/disk.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -38,4 +38,5 @@
 #include <block.h>
 #include <errno.h>
+#include <str_error.h>
 #include <io/log.h>
 #include <label/empty.h>
@@ -456,5 +457,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering callback "
-		    "for disk discovery (%d).", rc);
+		    "for disk discovery: %s.", str_error(rc));
 		return rc;
 	}
@@ -1124,5 +1125,5 @@
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering "
-		    "service %s (%d).", name, rc);
+		    "service %s: %s.", name, str_error(rc));
 		free(name);
 		free(part);
Index: uspace/srv/bd/vbd/vbd.c
===================================================================
--- uspace/srv/bd/vbd/vbd.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/bd/vbd/vbd.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -36,4 +36,5 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <io/log.h>
 #include <ipc/services.h>
@@ -69,5 +70,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
 		return EEXIST;
 	}
@@ -75,5 +76,5 @@
 	rc = loc_service_register(SERVICE_NAME_VBD, &ctl_sid);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service (%d).", rc);
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
 	}
Index: uspace/srv/clipboard/clipboard.c
===================================================================
--- uspace/srv/clipboard/clipboard.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/clipboard/clipboard.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -29,11 +29,12 @@
 #include <async.h>
 #include <errno.h>
+#include <str_error.h>
 #include <fibril_synch.h>
 #include <ipc/services.h>
 #include <ipc/clipboard.h>
 #include <loc.h>
-#include <malloc.h>
 #include <stdio.h>
 #include <stdbool.h>
+#include <stdlib.h>
 #include <task.h>
 
@@ -188,5 +189,5 @@
 	rc = loc_server_register(NAME);
 	if (rc != EOK) {
-		printf("%s: Failed registering server. (%d)\n", NAME, rc);
+		printf("%s: Failed registering server: %s\n", NAME, str_error(rc));
 		return rc;
 	}
@@ -194,5 +195,5 @@
 	rc = loc_service_register(SERVICE_NAME_CLIPBOARD, &svc_id);
 	if (rc != EOK) {
-		printf("%s: Failed registering service. (%d)\n", NAME, rc);
+		printf("%s: Failed registering service : %s\n", NAME, str_error(rc));
 		return rc;
 	}
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 7f4937e65b167991b71e24b530864b61b7145134)
+++ uspace/srv/devman/main.c	(revision 5340bfa17a8a9bf4c691594ca361efe8f52c7a43)
@@ -42,4 +42,5 @@
 #include <stdio.h>
 #include <errno.h>
+#include <str_error.h>
 #include <stdbool.h>
 #include <fibril_synch.h>
@@ -318,5 +319,5 @@
 	int rc = log_init(NAME);
 	if (rc != EOK) {
-		printf("%s: Error initializing logging subsystem.\n", NAME);
+		printf("%s: Error initializing logging subsystem: %s\n", NAME, str_error(rc));
 		return rc;
 	}
@@ -329,21 +330,29 @@
 	rc = async_create_port(INTERFACE_DDF_DRIVER,
 	    devman_connection_driver, NULL, &port);
-	if (rc != EOK)
-		return rc;
+	if (rc != EOK) {
+		printf("%s: Error creating DDF driver port: %s\n", NAME, str_error(rc));
+		return rc;
+	}
 	
 	rc = async_create_port(INTERFACE_DDF_CLIENT,
 	    devman_connection_client, NULL, &port);
-	if (rc != EOK)
-		return rc;
+	if (rc != EOK) {
+		printf("%s: Error creating DDF client port: %s\n", NAME, str_error(rc));
+		return rc;
+	}
 	
 	rc = async_create_port(INTERFACE_DEVMAN_DEVICE,
 	    devman_connection_device, NULL, &port);
-	if (rc != EOK)
-		return rc;
+	if (rc != EOK) {
+		printf("%s: Error creating devman device port: %s\n", NAME, str_error(rc));
+		return rc;
+	}
 	
 	rc = async_create_port(INTERFACE_DEVMAN_PARENT,
 	    devman_connection_parent, NULL, &port);
-	if (rc != EOK)
-		return rc;
+	if (rc != EOK) {
+		printf("%s: Error creating devman parent port: %s\n", NAME, str_error(rc));
+		return rc;
+	}
 	
 	async_set_fallback_port_handler(devman_forward, NULL);
@@ -357,5 +366,5 @@
 	rc = service_register(SERVICE_DEVMAN);
 	if (rc != EOK) {
-		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering as a service.");
+		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering as a service: %s", str_error(rc));
 		return rc;
 	}
